[[_TOC_]]

# 前言
`提示： 2019年8月华为推出鸿蒙HarmonyOS，并运用在荣耀智慧屏，HDC 2020，华为消费者业务软件部总裁王成录将在9月11日进行《共建、共享 HarmonyOS 生态》的演讲，将分享 HarmonyOS 2.0发布的新进展以及给人们、给行业带来的价值。`

<hr style=" border:solid; width:100px; height:1px;" color=#000000 size=1">

<font color=#999AAA >提示：以下是本篇文章正文内容，下面案例可供参考

# 一、鸿蒙OS是什么？
华为公司新近推出的经历十年多时间自主研发的鸿蒙操作系统（HarmonyOS），是基于微内核的全场景分布式OS，可按需扩展，实现更广泛的系统安全 。目前主要用于智能物联网，在将来无法使用Android时可扩展到智能手机上。HarmonyOS拥有分布架构、内核安全、生态共享、运行流畅四大优势，鸿蒙OS生态的两大核心要素包括自身的微内核结构和方舟编译器。

# 二、HarmonyOS的特点
## 1.HarmonyOS的设计与理念
鸿蒙OS是全新的基于微内核的面向全场景的分布式操作系统。鸿蒙OS的微内核已发展到seL4，如下图（图1所示）。seL4的核心非常小，不到9000行C代码。对于微内核，由于用内存管理单元MMU对进程空间进行隔离保护，没有授权的进程将无法访问其他进程的空间，从而阻止了恶意程序对其他进程数据的窃取。鸿蒙OS核心只保留了处理的时间、内存、通信、中断等基本的资源管理，所有其他功能由应用层来管理，以服务的形式去提供功能。服务之间采用进程间通信IPC。
![在这里插入图片描述](https://img-blog.csdnimg.cn/2020090216353752.png?x-oss-process=image/watermark,type_ZmFuZ3poZW5naGVpdGk,shadow_10,text_aHR0cHM6Ly9ibG9nLmNzZG4ubmV0L3dlaXhpbl80ODMwNDU3Mw==,size_16,color_FFFFFF,t_70#pic_center)
鸿蒙OS实现模块化耦合，对应不同设备可弹性部署；首次将分布式架构用于终端OS，实现跨终端无缝协同体验；采用的确定时延引擎和高性能IPC技术使系统更流畅；其基于微内核架构可重塑终端设备安全性；通过统一IDE支撑一次开发，多端部署，实现跨终端生态共享。

## 2.HarmonyOS的创新
2.1  内部解耦 为适应不同的硬件，鸿蒙OS把每一层内部都解耦，形成几千个模块，每个模块的接口全部用头文件写好，打上标签说明该模块是怎样的设备。可针对应不同设备进行弹性部署，如智慧屏、穿戴设备、车机、音箱、手机等，同时创新的分布式软总线使得拥有不同功能的硬件可以彼此协同。如传统的相机、电视、音响等设备原本相互独立，利用鸿蒙的分布式软总线，这些设备可被虚拟化成摄像模组、显示模组、外放模组，并成为有机整体，用户无需另行设置即可按需调用各种功能，硬件终端之间形成相互协同。

2.2  虚拟硬件 创新性地打破传统终端硬件的边界，使诸如手机中的显示器、处理器芯片、内存等等实体硬件，可以通过软件按需求组合成不同硬件形态的虚拟硬件功能模块。

2.3 一次开发多端部署 通过用户接口UI控件的抽象和解耦，业务逻辑原子化，不同应用的适配，可以快速实现一次开发并进行多端部署。鸿蒙OS从设计之初就为多,终端而生，如边缘计算、IoT、服务器等。

2.4  分布式微内核 鸿蒙OS的微内核所具有的分布式特点，有利于IoT的生态协同。现有各种操作系统只对应于某一种硬件，如Windows只对应x86 PC、iOS对应苹果手机等，无法满足IoT时代众多不同种类终端的需要，也无法针对每种硬件分别开发一种操作系统或应用程序，导致不同硬件终端的生态无法共享协同，开发效率低。因此鸿蒙OS在IoT应用中的优势更加明显。 

## 3.方舟编译器特点分析
方舟编译器是华为2019年4月在P30系列手机发布会上公布的，定位于多终端系统，可协助鸿蒙操作系统进入更深层次布局边缘计算、服务器等领域，大幅提升手机端安卓系统的运行效率。

**3.1  编译点提前** 
方舟编译器能够在应用程序执行之前，就将Java代码编译成机器语言，从而大量释放硬件资源，这对于多终端，尤其是物联网边缘计算尤为重要。克服了传统编译器边执行边翻译导致的程序执行效率低下，以及安卓系统虚拟机程序安装时间长的不足。方舟编译器将编译过程提前至开发环节，开发者能通过方舟预置算法进行代码优化，还可自行开发代码优化算法，未来代码优化甚至有可能迁移至云端。

**3.2 开发环境友好** 
开发环境友好是鸿蒙搭建良好生态的重要因素。兼容Java和C、C++等多种语言，增强了鸿蒙OS的性能，并与自有麒麟、鲲鹏等硬件架构协同，形成类似微软和英特尔联盟的软硬件格局。克服了过去采用Java和C/C++等多种语言混合开发应用程序时，传统编译器下跨语言应用执行效率较低的问题。
![在这里插入图片描述](https://img-blog.csdnimg.cn/20200902164758244.png?x-oss-process=image/watermark,type_ZmFuZ3poZW5naGVpdGk,shadow_10,text_aHR0cHM6Ly9ibG9nLmNzZG4ubmV0L3dlaXhpbl80ODMwNDU3Mw==,size_16,color_FFFFFF,t_70#pic_center)
## 4.HarmonyOS的应用研究

鸿蒙OS的出现将导致与iOS和Android成三足鼎立之 　　势。尽管华为的鸿蒙OS目前只作为5G手机中Android的备胎，据已公开的资料，鸿蒙OS的UI设计、系统逻辑以及App安装界面，与现在华为手机上的EMUI并没有明显区别，这使现有EMUI用户可以尽快习惯新系统，降低学习成本。此外，由于鸿蒙OS与Android保持兼容，通过方舟编译系统，原来的应用还能够提速60%以上。

鸿蒙OS的应用领域如图2所示。可应用于手机专有服务、智慧屏专有服务、穿戴设备专有服务、车机专有服务、音箱专有服务等领域，还可使这些不同设备协同工作，切换设备时实现无缝衔接。

鸿蒙OS使手机、电脑、汽车、智能穿戴等设备的操作系统实现兼容，有利于物联网的升级管理和兼容，成为将来走向智能社会的一个操作系统。

鸿蒙OS与具有高速、低延时、广接入的5G相结合，为智能手机与智能穿戴设备的联动、智能自动驾驶汽车、物联网系统提供了新的基础技术支撑。

华为鸿蒙（HarmonyOS）支持多种协议混合适配不同业务场景，用100多种品类的控制组件，向开发者提供最丰富的连接方式。由于华为做了30多年通信，连通本来就是强项，这点是意料之中。
![在这里插入图片描述](https://img-blog.csdnimg.cn/20200908155451212.png#pic_center)
用“1+8+N”来总结华为的战略，就显得很直观。

1：手机是一个核心入口；

8：PC、平板、智慧大屏、车机、耳机、音箱、手表、眼镜这八个大小屏入口；

N：摄像头、路由器、冰箱、空调等N种泛物联网设备。

HarmonyOS把各终端硬件的能力虚拟成可共享的能力资源池，让应用通过系统调用其所需的硬件能力。在这个架构下，硬件能力，类似活字印刷术中的一个个单字字模，可以被无限次重复使用。简单来说，各终端实现了硬件互助，资源共享；应用拥有了调用远程终端的能力（像调用本地终端一样方便）；而用户收获一个多设备组成的超级终端。

# 结束
<font color=#999AAA >

猛一看，鸿蒙系统占据着绝对的劣势。但从纵观移动操作系统十几年的起起伏伏，鸿蒙系统并非没有机会。在2007年第二季度，塞班系统占据着63.75%的市场份额，Windows Mobile及BlackBerry OS则分别占据10&左右市场份额

虽然目前主流操作系统大多被国外垄断，我国华为公司的HarmonyOS虽然起步不久，但却具有许多独特优势，其改进的跨平台功能、支持多场景应用、可以在各种设备和平台上使用、可以满足消费者对低延迟和强安全性需求的特点，使其具有广阔的应用前景。

在硬件和软件之间，中国产业界一向“重硬轻软“。毕竟，硬件更容易被消费者感知，加一个摄像头、上一个大屏幕，用户一眼就看到了，发布会和营销都好找噱头。但是，软件，尤其是基础软件的革新，用户感知有很大很大的滞后性。因此，企业对于基础软件的投资，常常不被理解，甚至引来冷嘲热讽，这背后，是中国产业界普遍浮躁、急功近利的心态。

从华为的历史来看，它是一家十分耐得住寂寞的公司。往远了说，80年代创业之初代理交换机就很赚钱，任正非却偏偏要赌上一切搞如此高风险的自主研发；往近了说，当年海思何曾被被看好过，最初几代产品也是在你我的嘲笑中成长，最终十年磨一剑，终成大器。


[【如果您想学习HarmonyOS 应用开发基础教程 请猛戳】](https://blog.csdn.net/weixin_48304573/category_10353183.html)

<font color=#999AAA >以上内容节选自取自HarmonyOS特点与应用前景分析：四川工业科技学院电子信息与计算机工程学院 李艳\刘丹\田小东\谭琦